#!/usr/bin/python
##### Polarni smerni diagrami osnih skupin - S53MV 12.2.2018 #####

import math,numpy	#uporabljene funkcije

def smerni(kh,fi,t):	#smerni diagram skupine dveh virov
	return abs(math.cos(fi/2+kh/2*math.cos(t)))

k=0.01		#korak risanja v radianih

xk=[]		#polja za risanje kroga
yk=[]
x1=[]		#polja za risanje funkcije
y1=[]
x2=[]
y2=[]
x3=[]
y3=[]

kh1=0.357*2*math.pi	#osna skupina h=0.357*lambda, fi=-kh
fi1=-kh1
D1=(1+math.cos(fi1+kh1))/(1+math.sin(kh1)/kh1*math.cos(fi1))
print kh1,fi1,D1
kh2=0.1*2*math.pi	#osna skupina h=0.1*lambda, fi=pi+kh/3
fi2=math.pi+kh2/3
D2=(1+math.cos(fi2+kh2))/(1+math.sin(kh2)/kh2*math.cos(fi2))
print kh2,fi2,D2
kh3=0.001*2*math.pi	#osna skupina h=0.001*lambda, fi=pi+kh/3
fi3=math.pi+kh3/3
D3=(1+math.cos(fi3+kh3))/(1+math.sin(kh3)/kh3*math.cos(fi3))
print kh3,fi3,D3

t=-math.pi+k/2		#kot theta v radianih
r2=0
r3=0
while t<math.pi:
	xk=xk+[math.sin(t)]	#referencni enotni krog
	yk=yk+[math.cos(t)]
	x1=x1+[math.sin(t)*smerni(kh1,fi1,t)]
	y1=y1+[math.cos(t)*smerni(kh1,fi1,t)]
	x2=x2+[math.sin(t)*smerni(kh2,fi2,t)]
	y2=y2+[math.cos(t)*smerni(kh2,fi2,t)]
	if r2<smerni(kh2,fi2,t):
		r2=smerni(kh2,fi2,t)
	x3=x3+[math.sin(t)*smerni(kh3,fi3,t)]
	y3=y3+[math.cos(t)*smerni(kh3,fi3,t)]
	if r3<smerni(kh3,fi3,t):
		r3=smerni(kh3,fi3,t)
	t=t+k			#povecaj t za korak

x2=numpy.divide(x2,r2)	#normalizacija diagrama 2
y2=numpy.divide(y2,r2)
x3=numpy.divide(x3,r3)	#normalizacija diagrama 3
y3=numpy.divide(y3,r3)

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(xk,yk,'k-')		#referencni enotni krog
plt.plot([-1,1],[0,0],'k-')	#koordinatne osi
plt.plot([0,0],[-1,1],'k-')
plt.plot(x1,y1,'b-')		#risanje funkcij
plt.plot(x2,y2,'g-')
plt.plot(x3,y3,'r-')
plt.axis([-1.05,1.05,-1.05,1.05])
plt.xticks([])
plt.yticks([])
plt.title('Primerjava smernih diagramov osnih skupin')
plt.xlabel('Os z')
plt.ylabel('Ravnina xy')
plt.axes().set_aspect('equal')
plt.show()

#konec programa

